jQuery(document).ready(function(){
    //set a localStorage (rex_current_popup_option_id) variable to store the ID of current option, reset this ID to 0 when
    // * user click on create new option
    // Change this ID based on option select change (rex_list_of_options)

    /*
     Load current popups and populate in the dropdown //
     */

    var data = {
        action: "rex_get_all_popups_widgets",
        type: "popup"
    };
    var popup_array;
    jQuery.post(ajaxurl, data, function(response){
        popup_array = rex_parse_json_output(response);

        //populate the poups to the popup selector
        var options = "<option value=''></option>";
        for (var i = 0; i < popup_array.length; i ++)
        {
            options += '<option value="'+popup_array[i].id+'">'+rex_de_serialize_data(popup_array[i].name)+'</option>';
        }

        jQuery("#rex_current_popup").text("");
        jQuery("#rex_current_popup").append(options);
    });


    rex_get_all_categories("#on_category_value");
    /* ==========================================================================
     Functions for CREATING popups options
     ========================================================================== */

    jQuery("#rex_create_option").click(function(){

        jQuery("#rex_edit_option").removeClass("rex-header-active");
        jQuery(this).removeClass("rex-header-active");
        jQuery(this).addClass("rex-header-active");

        localStorage.setItem("rex_current_popup_option_id", 0);
        jQuery("#rex_manager_left input, #rex_manager_left select").val("");


        jQuery("#rex_option_label").text("Give a name for this option");
        jQuery("#rex_created_options").fadeOut();
        jQuery("#rex_option_settings").fadeIn();

        jQuery("#rex_get_shortcode").fadeOut();
        jQuery("#rex_delete_option").fadeOut();

    });


    /* ==========================================================================
     Functions for EDITING popups options
     ========================================================================== */
    jQuery("#rex_edit_option").click(function(){
        jQuery("#rex_create_option").removeClass("rex-header-active");
        jQuery(this).addClass("rex-header-active");

        jQuery("#rex_option_label").text("Current option's name");

        //get all available popups and put into the option selection to start editing
        var data = {
            action: "rex_get_popup_widget_options",
            type: "popup"
        };

        jQuery.post(ajaxurl, data, function(response){
            var options_array = rex_parse_json_output(response);


            var options = "<option value=''></option>";
            for (var i = 0; i < options_array.length; i ++)
            {
                options += '<option value="'+options_array[i].id+'">'+rex_de_serialize_data(options_array[i].title)+'</option>';
            }

            jQuery("#rex_list_of_options").html("");
            jQuery("#rex_list_of_options").append(options);
            //present the UI to use
            jQuery("#rex_created_options").fadeIn();
            jQuery("#rex_option_settings").fadeIn();


            //reset values for all fields
            jQuery("#rex_manager_left input, #rex_manager_left select").val("");
        });

        jQuery("#rex_get_shortcode").fadeOut();
        jQuery("#rex_delete_option").fadeOut();

    });

    //populate single options to the list of options


    /* ==========================================================================
     SAVE BUTTON BEHAVIOR. USE FOR BOTH CREATE AND EDIT OPTIONS
     ========================================================================== */
    //show the list of categories when users select the popup to be shown on specific categories
    jQuery(document).on("change", "#rex_display_location", function(){
        if (jQuery(this).val() == "on_category")
        {
            jQuery("#on_category_value").parent().fadeIn();
        } else
        {
            jQuery("#on_category_value").parent().fadeOut();
        }
    });

    //set background for the popup
    jQuery(document).on("change", "#rex_popup_background", function(){

        var this_value = jQuery(this).val();
        var this_input_id = this_value + "_value";

        /*
        if user selects trans black or trans, don't show extra box, other show the equivalent boxes for the selected option
        since the id of the boxes = value of the option + _value
         */
        if (this_value == "transparent_black" || this_value == "transparent")
        {
            jQuery("#rex_for_popup_bg div").hide();

        } else
        {

            jQuery("#rex_for_popup_bg div").hide();
            jQuery("#"+this_input_id).parent().show();

        }

    });

    jQuery(document).on("change", "#rex_when_to_show", function(){

        var this_val = jQuery(this).val();
        var this_input_id = this_val + "_value";
        if (jQuery(this).val() == "mouse_exits")
        {
            jQuery("#rex_for_showing_behavior div").hide();


        } else
        {
            jQuery("#rex_for_showing_behavior div").hide();
            jQuery("#"+this_input_id).parent().show();
        }

    });


    //SAVE OPTION TO DB
    jQuery("#rex_popup_save_option").click(function(){

        if (rex_check_input_in_manage("#rex_option_settings input, #rex_option_settings select") == "stop")
        {

            rex_general_notification("warning", "You forgot to set an option", 3);
            return false;
        }

        var bg_type = jQuery("#rex_popup_background").val();
        var bg_value = "";


        if (jQuery("#"+bg_type +"_value").length != 0)
        {
            if (jQuery("#"+bg_type +"_value").val() == "")
            {
                jQuery("#"+bg_type +"_value").css("border", "1px dashed #ff0000");
                rex_general_notification("warning", "You forgot to set an option", 3);
                rex_remove_attr(jQuery("#"+bg_type +"_value"), "style", 2);
                return;
            } else
            {
                bg_value = jQuery("#"+bg_type +"_value").val();
            }
        }

        var trigger_type = jQuery("#rex_when_to_show").val();
        var trigger_value = 0;
        if (jQuery("#"+trigger_type +"_value").length != 0)
        {
            if (jQuery("#"+trigger_type +"_value").val() == "")
            {
                jQuery("#"+trigger_type +"_value").css("border", "1px dashed #ff0000");
                rex_general_notification("warning", "You forgot to set an option", 3);
                rex_remove_attr(jQuery("#"+trigger_type +"_value"), "style", 2);
                return;
            } else
            {
                trigger_value = jQuery("#"+trigger_type +"_value").val();
            }

        }
        //end checking values
        console.log("passed test");

        //get values of all settings
        var option_title        = jQuery("#rex_option_name").val();
        var popup_id            = jQuery("#rex_current_popup").val();
        var display_position    = jQuery("#rex_popup_position").val();
        var appear_location     = jQuery("#rex_display_location").val();
        var appear_categories   = rex_serialize_data(JSON.stringify(rex_get_checked_categories("#on_category_value")));
        var animation           = jQuery("#rex_popup_animation").val();
        var frequency           = jQuery("#rex_popup_display_frequency").val();
        var option_id           = localStorage.getItem("rex_current_popup_option_id");
        var activated           = jQuery("#rex_active_popup").val();

        var data = {
            action              : "rex_save_popup_option",
            option_title        : rex_serialize_data(option_title),
            popup_id            : popup_id,
            appear_location     : appear_location,
            appear_categories   : appear_categories,
            display_position    : display_position,
            popup_background    : bg_type,
            background_value    : bg_value,
            popup_trigger_type  : trigger_type,
            popup_trigger_value : trigger_value,
            animation           : animation,
            frequency           : frequency,
            option_id           : option_id,
            activated           : activated


        };
        //send POST request to save this option
        jQuery.post(ajaxurl, data, function(response){
            var return_data = rex_parse_json_output(response);

            console.log(return_data);
            console.log(return_data["option_id"]);

            rex_general_notification('success', return_data["message"], 4);
            localStorage.setItem("rex_current_popup_option_id", return_data["option_id"]);


            jQuery("#rex_get_shortcode").fadeIn();
            jQuery("#rex_delete_option").fadeIn();
        });

        //flush the list of currrent option to the latest values (in case user changes the option's title)


    });

    /* ==========================================================================
     EDIT OPTIONS
     ========================================================================== */
    jQuery(document).on("change", "#rex_list_of_options", function(){
        /*
        0. Set current option id to selected option id
        1. Get option ID
        2. Get option values
        3. Append values to appropriate boxes
         */
        var option_id = jQuery(this).val();
        localStorage.setItem("rex_current_popup_option_id", option_id);

        var data = {
            action      : "rex_get_option_details",
            option_id   : option_id
        };

        jQuery.post(ajaxurl, data, function(response){

            //set current option name to current option name, hah
            var selected_option_id = jQuery("#rex_list_of_options").val();
            if (selected_option_id == "")
            {
                return;
            }

            jQuery("#rex_option_name").val(jQuery("#rex_list_of_options option[value="+selected_option_id+"]").text());

            //reset current option ID
            localStorage.setItem("rex_current_popup_option_id", selected_option_id);

            var return_data = rex_parse_json_output(response);

            for (var key in return_data)
            {
                if (jQuery("#"+key).length != 0)
                {
                    jQuery("#"+key).val(return_data[key]);

                    //set value for the background when available
                    if (key == "rex_popup_background")
                    {
                        jQuery("#"+return_data[key]+"_value").val(return_data["background_value"]);
                        jQuery("#"+return_data[key]+"_value").parent().fadeIn();

                    } else

                    //set value for trigger type when avaialble
                    if (key == "rex_when_to_show")
                    {
                        jQuery("#"+return_data[key]+"_value").val(return_data["trigger_value"]);
                        jQuery("#"+return_data[key]+"_value").parent().fadeIn();
                    } else

                    if (key == "rex_display_location")
                    {
                        jQuery("#"+key).val(return_data[key]);

                        //when the option was set to on_category, get the selected options and make them selected in the select box
                        if (return_data[key] == "on_category" )
                        {
                            jQuery("#on_category_value").parent().fadeIn();
                            var selected_categories = JSON.parse(rex_de_serialize_data(return_data["rex_display_categories"]));

                            rex_check_checked_categories(selected_categories, "#on_category_value");

                        }
                    }


                } else if (key == "item_id")
                {
                    jQuery("#rex_current_popup").val(return_data[key]);
                }
            }


            jQuery("#rex_get_shortcode").fadeIn();
            jQuery("#rex_delete_option").fadeIn();
        });
    });



});