jQuery(document).ready(function(){
    //set a localStorage (rex_current_widget_option_id) variable to store the ID of current option, reset this ID to 0 when
    // * user click on create new option
    // Change this ID based on option select change (rex_list_of_options)

    /*
     Load current widgets and populate in the dropdown //
     */

    localStorage.setItem("rex_current_widget_option_id", 0);
    var data = {
        action: "rex_get_all_popups_widgets",
        type: "widget"
    };

    var widget_array;
    jQuery.post(ajaxurl, data, function(response){
        widget_array = rex_parse_json_output(response);

        //populate the poups to the widget selector
        var options = "<option value=''></option>";
        for (var i = 0; i < widget_array.length; i ++)
        {
            options += '<option value="'+widget_array[i].id+'">'+rex_de_serialize_data(widget_array[i].name)+'</option>';
        }
        jQuery("#rex_selected_widget_id").text("");
        jQuery("#rex_selected_widget_id").append(options);
    });

    rex_get_all_categories("#on_category_value");


    /* ==========================================================================
     Functions for CREATING widgets options
     ========================================================================== */

    jQuery("#rex_create_option").click(function(){
        jQuery("#rex_edit_option").removeClass("rex-header-active");
        jQuery(this).addClass("rex-header-active");

        localStorage.setItem("rex_current_widget_option_id", 0);
        jQuery("#rex_manager_left input, #rex_manager_left select").val("");


        jQuery("#rex_option_label").text("Give a name for this option");
        jQuery("#rex_created_options").fadeOut();
        jQuery("#rex_option_settings").fadeIn();

        jQuery("#rex_get_shortcode").fadeOut();
        jQuery("#rex_delete_option").fadeOut();

    });


    /* ==========================================================================
     Functions for EDITING widgets options
     ========================================================================== */
    jQuery("#rex_edit_option").click(function(){
        jQuery("#rex_create_option").removeClass("rex-header-active");
        jQuery(this).addClass("rex-header-active");

        jQuery("#rex_get_shortcode").fadeOut();
        jQuery("#rex_delete_option").fadeOut();


        jQuery("#rex_option_label").text("Current option's name");

        //get all available widgets and put into the option selection to start editing
        var data = {
            action: "rex_get_popup_widget_options",
            type: "widget"
        };

        jQuery.post(ajaxurl, data, function(response){
            var options_array = rex_parse_json_output(response);


            var options = "<option value=''></option>";
            for (var i = 0; i < options_array.length; i ++)
            {
                options += '<option value="'+options_array[i].id+'">'+rex_de_serialize_data(options_array[i].title)+'</option>';
            }

            jQuery("#rex_list_of_options").html("");
            jQuery("#rex_list_of_options").append(options);
            //present the UI to use
            jQuery("#rex_created_options").fadeIn();
            jQuery("#rex_option_settings").fadeIn();


            //reset values for all fields
            jQuery("#rex_manager_left input, #rex_manager_left select").val("");
        });



    });

    //populate single options to the list of options


    /* ==========================================================================
     SAVE BUTTON BEHAVIOR. USE FOR BOTH CREATE AND EDIT OPTIONS
     ========================================================================== */

    //show the list of categories when users select the widget to be shown on specific categories
    jQuery(document).on("change", "#rex_display_location", function(){
        if (jQuery(this).val() == "on_category")
        {
            jQuery("#on_category_value").parent().fadeIn();
        } else
        {
            jQuery("#on_category_value").parent().fadeOut();
        }
    });

    //Save the option
    jQuery("#rex_widget_save_option").click(function(){


        if (rex_check_input_in_manage(("#rex_option_settings input, #rex_option_settings select")) == "stop")
        {
            rex_general_notification("warning", "You forgot to set an option", 3);
            return false;
        }

        if (jQuery("#rex_display_location").val() == "on_category" && rex_get_checked_categories("#on_category_value").length == 0)
        {
            rex_general_notification("warning", "You forgot to set category", 3);
            return false;
        }

        console.log("passed test");


        //get values of all settings
        var rex_option_title                = jQuery("#rex_option_title").val();
        var rex_selected_widget_id          = jQuery("#rex_selected_widget_id").val();
        var rex_display_location     = jQuery("#rex_display_location").val();
        var rex_display_categories   = rex_serialize_data(JSON.stringify(rex_get_checked_categories("#on_category_value")));
        var rex_widget_position_in_post     = jQuery("#rex_widget_position_in_post").val();
        var rex_active_widget               = jQuery("#rex_active_widget").val();
        var type                            = "widget";

        var data = {
            action                         : "rex_save_widget_option",
            rex_option_title               : rex_serialize_data(rex_option_title),
            rex_selected_widget_id         : rex_selected_widget_id,
            rex_display_location    : rex_display_location,
            rex_display_categories  : rex_display_categories,
            rex_widget_position_in_post    : rex_widget_position_in_post,
            rex_active_widget              : rex_active_widget,
            type                           : type,
            option_id                      : localStorage.getItem("rex_current_widget_option_id")

        };
        //send POST request to save this option
        jQuery.post(ajaxurl, data, function(response){
            var return_data = rex_parse_json_output(response);

            console.log(return_data);
            console.log(return_data["option_id"]);

            rex_general_notification('success', return_data["message"], 4);
            localStorage.setItem("rex_current_widget_option_id", return_data["option_id"]);

            jQuery("#rex_get_shortcode").fadeIn();
            jQuery("#rex_delete_option").fadeIn();

        });

        //flush the list of current option to the latest values (in case user changes the option's title)

    });

    /* ==========================================================================
     EDIT OPTIONS
     ========================================================================== */
    jQuery(document).on("change", "#rex_list_of_options", function(){
        /*
         1. Get option ID
         2. Get option values
         3. Append values to appropriate boxes
         */
        var option_id = jQuery(this).val();

        var data = {
            action      : "rex_get_option_details",
            option_id   : option_id
        };

        jQuery.post(ajaxurl, data, function(response){

            //set current option name to current option name, hah
            var selected_option_id = jQuery("#rex_list_of_options").val();
            if (selected_option_id == "")
            {
                return;
            }

            //reset current option ID
            localStorage.setItem("rex_current_widget_option_id", selected_option_id);

            var return_data = rex_parse_json_output(response);

            for (var key in return_data)
            {
                //display_location has special additional value, so it needs a different case
                if (key == "rex_display_location")
                {
                    jQuery("#"+key).val(return_data[key]);

                    //when the option was set to on_category, get the selected options and make them selected in the select box
                    if (return_data[key] == "on_category" )
                    {
                        jQuery("#on_category_value").parent().fadeIn();
                        var selected_categories = JSON.parse(rex_de_serialize_data(return_data["rex_display_categories"]));

                        rex_check_checked_categories(selected_categories, "#on_category_value");

                    }

                } else if (jQuery("#"+key).length != 0)
                {
                    jQuery("#"+key).val(return_data[key]);


                } else if (key == "item_id")
                {
                    jQuery("#rex_current_widget").val(return_data[key]);
                }
            }

            jQuery("#rex_option_title").val(jQuery("#rex_list_of_options option[value="+selected_option_id+"]").text());


            jQuery("#rex_get_shortcode").fadeIn();
            jQuery("#rex_delete_option").fadeIn();
        });
    });




});